<?

class Mail {
	var $mSendType;
	var $mCharSet = "iso-8859-1";
	var $mContentType = "text/plain";
	var $mHostName = "localhost";
	var $mSender;
	var $mReceiver;
	var $mReceiverCC;

    function Mail($type='standard') {
    	$this->mSendType = $type;
    }
    
    function setCharSet($value) {
    	$this->mCharSet = $value;
    }
    
    function setContentType($value) {
    	$this->mContentType = $value;
    }
    
    function setHostName($value) {
    	$this->mHostName = $value;
    }
    
    function setReceiver($value) {
    	$this->mReceiver = $value;
    }
    
    function setReceiverCC($value) {
    	$this->mReceiverCC = $value;
    }
    
    function setSender($value) {
    	$this->mSender = $value;
    }
    
    function Send($subject,$data) {
    	$headers = "From: ".$this->mSender."\n";
    	if (isset($this->mReceiverCC)) $headers .= "CC: ".$this->mReceiverCC."\n";
    	$headers .= "Subject: $subject\n";
    	$headers .= "X-Sender: <".$this->mSender.">\n";
    	$headers .= "X-Mailer: PHP\n";
    	$headers .= "X-Priority: 3\n";
    	$headers .= "Return-Path: <".$this->mSender.">\n";
    	$headers .= "Mime-Version: 1.0\n";
    	$headers .= "Content-Type: ".$this->mContentType."; charset=".$this->mCharSet."\n";
    	$headers .= "Content-Transfer-Encoding: 8bit";

    	switch ($this->mSendType) {
    		case "standard":
    		mail($this->mReceiver, $subject, $data, $headers);
    		break;
    
    		case "smtp":
    		$smtp = new TSmtp;
    		$data = $headers."\n\n".$data;
    		$smtp->Send($this->mHostName,$this->mSender,$this->mReceiver,$data);
    		unset($smtp);
    		break;
    	}
    }

}

class TSmtp {
  var $mFp = false;
  var $mLastMsg = "";
  var $mError = false;


  function ReadLine() {
    $ret = false;
	$line = fgets($this->mFp,1024);
	if (ereg("^([0-9]+).(.*)$", $line, &$data)) {
	  $recv_code = $data[1];
	  $recv_msg = $data[2];
	  $ret = array($recv_code,$recv_msg);
	}
	return $ret;
  }


  function Dialogue($code, $cmd) {
    $ret = true;
    if (!$this->mError) {
	fwrite( $this->mFp, $cmd . "\r\n" );
	$line = $this->ReadLine();
	if ($line == false) {
	  $this->LastMsg = "";
	  $ret = false;
	} else {
	  $this->LastMsg = "$line[0] $line[1]";
	  if ($line[0] != $code) $ret = false;
	}
	} //if !Error
	return $ret;
  }


  function ErrorMessage($errorMsg="") {
  	$this->mError = true;
	if ($errorMsg) {
		echo $errorMsg."<br>";
	} else {
	    echo "SMTP protocol failure (".$this->LastMsg.").<br>";
	}
	return true;
  }


  function CrlfEncode($data) {
    $data .= "\n";
	$data = str_replace("\n", "\r\n", str_replace("\r", "", $data));
	$data = str_replace("\n.\r\n", "\n. \r\n", $data);
	return $data;
  }

  function HandleEmail($from, $to, $data) {
    $rcpts = explode(",",$to);
	if ( !$this->Dialogue(250,"HELO #phpclient") ) $this->ErrorMessage();
	if ( !$this->Dialogue(250,"MAIL FROM:$from") ) $this->ErrorMessage();
	for ($i = 0; !$err && $i < count($rcpts); $i++) {
	  if (!$this->Dialogue(250,"RCPT TO:$rcpts[$i]")) $this->ErrorMessage();
	}
	if ( !$this->Dialogue(354, "DATA") || !fwrite($this->mFp,$data) || 
		 !$this->Dialogue(250,"\r\n.") || !$this->Dialogue(221, "QUIT")) {
	  $this->ErrorMessage();
	}
	return $this->mError;
  }


  function Connect($hostname) {
	$this->mFp = fsockopen($hostname,25);
	if (!$this->mFp) $this->ErrorMessage("Cannot open socket<br>\n");
	return !$this->mError;
  }


  function Send($hostname,$from,$to,$data,$crlfEncode = 0) {
    if (!$this->Connect($hostname)) return false;
	$line = $this->ReadLine();
	if ( $line && $line[0] == "220" ) {
	  if ($crlfEncode) {
	    $data = $this->CrlfEncode($data);
	  }
	  $this->HandleEmail($from,$to,$data);
	} else {
	  $this->ErrorMessage();
	}
	fclose($this->mFp);
	return $this->mError;
  }
}
?>