<?php
// +----------------------------------------------------------------------+
// | WR Time Tracker
// +----------------------------------------------------------------------+
// | Copyright (c) 2004-2005 WR Consulting (http://www.wrconsulting.com)
// +----------------------------------------------------------------------+
// | LIBERAL FREEWARE LICENSE: This source code document may be used
// | by anyone for any purpose, and freely redistributed alone or in
// | combination with other software, provided that the license is obeyed.
// |
// | There are only two ways to violate the license:
// |
// | 1. To redistribute this code in source form, with the copyright
// |    notice or license removed or altered. (Distributing in compiled
// |    forms without embedded copyright notices is permitted).
// |
// | 2. To redistribute modified versions of this code in *any* form
// |    that bears insufficient indications that the modifications are
// |    not the work of the original author(s).
// |
// | This license applies to this document only, not any other software
// | that it may be combined with.
// |
// +----------------------------------------------------------------------+
// | Contributors: Sergey Kikot <skikot@wrconsulting.com>
// +----------------------------------------------------------------------+

	require_once('initialize.php');
	import('form.Form');
	import('UserHelper');

	if ($auth->isAuthenticated()) {
		$user = new User($auth->getUserId());
	} else {
		Header("Location: login.php");
		exit();
	}

	$cl_userid = (int)$request->getParameter('ppl_id');
	if ($cl_userid>0) {
		$_SESSION["cl_userid"] = $cl_userid;
	}
	if ($cl_userid==0) {
		$cl_userid = $_SESSION["cl_userid"];
	}
	
	$ud = UserHelper::findUserById($cl_userid, $user);
	
    if ($request->getMethod()=="POST") {
		$cl_name  = $request->getParameter('name');
		$cl_name  = trim($cl_name);
		$cl_email  = $request->getParameter('email');
		$cl_email	= trim(strtolower($cl_email));
		$cl_password1	= $request->getParameter('pas1');
  		$cl_password2	= $request->getParameter('pas2');
  		$cl_rate	= $request->getParameter('rate');
	} else {
        $cl_name	= $ud["u_name"];
        $cl_email	= $ud["u_login"];
        $cl_password1 = $cl_password2 = $ud["u_password"];
        $cl_rate = str_replace(".",$i18n->getFloatDelimiter(),$ud["u_rate"]);
	}
        
	$form = new Form('peopleForm');
	$form->addInput(array("type"=>"text","maxlength"=>"100","name"=>"name","value"=>$cl_name));
    $form->addInput(array("type"=>"text","maxlength"=>"100","name"=>"email","value"=>$cl_email));
    $form->addInput(array("type"=>"text","maxlength"=>"30","name"=>"pas1","aspassword"=>true,"value"=>$cl_password1));
    $form->addInput(array("type"=>"text","maxlength"=>"30","name"=>"pas2","aspassword"=>true,"value"=>$cl_password2));
    $form->addInput(array("type"=>"floatfield","maxlength"=>"10","name"=>"rate","format"=>".2","value"=>$cl_rate));
    $form->addInput(array("type"=>"hidden","name"=>"ppl_id","value"=>$cl_userid));
	$form->addInput(array("type"=>"submit","name"=>"btsubmit","value"=>$i18n->getKey('button.save')));
	
	if ($request->getMethod()=="POST") {
		import('form.check.Validator');
		
		$validator = new Validator($cl_name);
		$validator->validateSpaceString();
		$validator->validateEmptyString();
		if (!$validator->isValid()) {
			$errors->add("name",$i18n->getKey("errors.wrong"),$i18n->getKey("form.people.name"));	
		}
		
		$validator = new Validator($cl_email);
		$validator->validateSpaceString();
		$validator->validateEmptyString();
		$validator->validateLatinCharset();
		if (!$validator->isValid()) {
	    	$errors->add("email",$i18n->getKey("errors.wrong"),$i18n->getKey("form.people.email"));
	    }
	    
	    $validator = new Validator($cl_password1);
		//$validator->validateSpaceString();
		$validator->validateEmptyString();
		//$validator->validateLatinCharset();
    	if (!$validator->isValid()) {
    		$errors->add("password",$i18n->getKey("errors.wrong"),$i18n->getKey("form.people.pas1"));
    	} elseif (!($cl_password1 === $cl_password2))
    		$errors->add("passwords",$i18n->getKey("errors.compare"),$i18n->getKey("form.people.pas1"),$i18n->getKey("form.people.pas2"));
    		
    	$validator = new Validator($cl_rate);
		$validator->validateFloat($i18n->getFloatDelimiter());
		if ($cl_rate && !$validator->isValid()) {
	    	$errors->add("rate",$i18n->getKey("errors.wrong"),$i18n->getKey("form.people.rate"));
	    }
    
		if ($errors->isEmpty()) {
			$ulo = UserHelper::findUserByLogin($cl_email);
			if (($ulo && $cl_userid==$ulo["u_id"]) || (!$ulo) ) {
				if (UserHelper::updateEmployee($user, $cl_userid, $cl_name, $cl_email, $cl_password1, $cl_rate)) {
					// reload personal data for current user
					if ($cl_userid==$user->getUserId()) $user->setUserId($user->getUserId());
					
					Header("Location: people.php");
					exit();
				} else
					$errors->add("edituser",$i18n->getKey("errors.user_update"));
			} else 
				$errors->add("edituser",$i18n->getKey("errors.user_exist"));
		}			
	} // post
	
	if (!$errors->isEmpty()) {
		$smarty->assign("errors", $errors->getErrors() );
	}
    $smarty->assign("forms",array($form->getName()=>$form->toArray()));
    $smarty->assign("onload","onLoad = \"document.peopleForm.name.focus()\"");
    $smarty->assign("userdet_string",UserHelper::getUserDetailsString($user,$GLOBALS["I18N"]));
    $smarty->assign("title_page",$i18n->getKey("form.people.edit_str"));
  	if ($ud) {
    	$smarty->assign("content_page_name","people_edit.tpl");
    } else {
    	$smarty->assign("content_page_name","syserror.tpl");
    }
  	$smarty->display(INDEX_TEMPLATE);
?>